import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
import java.awt.Font;

/**
 * The Msg is used to display results on the screen. It can display some
 * text and several numbers.
 * 
 * @author (Alsbouaya Ali)
 * @version 2.0
 */
public class Msg extends Actor
{  
       /**
     * Msg is calling showMsg function to show the Game Over title and the score
     * @param Parameter score has the last score that the player got
     */
    public Msg(int score)
    {
        showMsg("Game Over", "Score: ", score);
    }
    
    

    /**
     * showMsg is a function to show " Game Over" message and the final score
     * @param Parameter msg1 is " Game Over" title
     * @param Parameter 
     * @param Parameter score
     */
    private void showMsg(String msg1, String msg2, int score)
    {
        // Create an image called image to show the Game Over message on it.
        GreenfootImage image = new GreenfootImage(400, 300);
        // Give the image a color
        image.setColor(new Color(0, 0, 0, 160));
        // fill that image with the same color
        image.fillRect(0, 0, 400, 300);
        // Choose a font
        Font font = image.getFont();
        font = font.deriveFont(48.0f);
        // Use that font to the image
        image.setFont(font);
        // Choose color to font
        
        image.setColor(Color.RED);
        // write msg1 which represent the Game Over title
        image.drawString(msg1, 60, 100);
        // write msg which represent the " Score " word and concatinate it with the last score that the player got
        image.drawString(msg2 + score, 60, 200);
        // Put that image on the world
        setImage(image);
        // After the following function,, player hears Buzz sound 
        Greenfoot.playSound("stop.wav");
    }
}
