import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font; 


/**
 * The ball1 class is the main class of the whole project.
 * It does the following main steps:
 * 1. Give the main objects a specific place on my world.The main objects are Score, Time, and Green Ball,
 * 2. Calling Act function which is calling randomGballs and randomsballs functions.
 *    Note: randomGballs to generate Gold balls randomly
 *        randomSballs to generate the Silver balls randomly
 * 3. calling funOver function which stops the game if you reach the target Time.
 * 
 * 
 * @author (Alsbouaya Ali) 
 * @version Jan. 31, 2011
 */
public class ball1  extends World
{
  // Create an object called Time from the Score class
  private Score Time;
  // Given an initial value to the theTime variable
  private int theTime=0;
  
   // delay to slow down the time
   private int delay=800;
  
   private int timer;
   // target_time: Determin what time this game will stop. At that time, check what score that the player got
   private int target_time=10;
   
   // Create a player object from the Ball class
   private Ball Player;
   
   // Give values to fTag, fTag2, and fTag3 messages
   Tag fTag= new Tag("Instructions to Play: (1)Use Arrow keys to move the Green Ball.");
   Tag2 fTag2= new Tag2("                              (2)Hit Gold and Silver balls: Earn 10,5 points respectively. ");
   Tag3 fTag3= new Tag3("                               (3)Game will STOP in 10 Sec. Try to hit maximum balls!");
    

    /**
     * Constructor for objects of class ball1.
     * 1.  Giving a color to the background.
     * 2.  Add the Green Ball to the world.
     * 3.  Add Gold and Silver Balls randomly.
     * 
     */
    public ball1()
    {    
        // Create a new world with 1000*600 cells with a cell size of 1x1 pixels.
        super(1000, 600, 1);
        // Determine a position to fTag, fTag2, and fTag3 to show the messages
        addObject(fTag, getWidth()/2, (getHeight()/2)+3);
        addObject(fTag2, getWidth()/2, (getHeight()/2)+30);
        addObject(fTag3, getWidth()/2, (getHeight()/2)+57);
      
        // Given an initial value for the Time object
        Time=new Score("0");  
       // initially timer has the same value as the delay
       timer=delay;
       
       GreenfootImage background = getBackground();
       // Give the background a black color
       background.setColor(Color.BLACK);
       background.fill();
       // Add the Green ball as a new object
       Player= new Ball();
       addObject(Player, 500, 500);
       // Add the Time object     
       addObject( Time, 600, 50); 
       
     //  addObject(new Tag(),getWidth()/2,getHeight()/2);
      // getWorld().remove(Tag.class);
       // After the following function palyer hear the start clupping hand and waves
       Greenfoot.playSound("start.wav");
      
}


/**
 * Act does the following 4 steps:  
 * 1. increment the timer slowly by having the delay variable
 * 2. generate the Gold and teh Silver Balls randomly.
 * 3. calling the funOver function which means the fun is over each time u are reaching the target_time vaeribale which is deceared above
 * 4. change the time and show it on the screen
 */

public void act()
{
// Slow down the time
   if(timer<=0)
   {
     theTime++;
     timer=delay;
     // calling the following functions will generate the Gold and the Silver balls randomly
     randomGballs();
     randomSballs();
     randomGballs();
     randomSballs();
  // Now we have to check if the player reached the target time which has been chosen previously
     if(theTime==target_time)
       // call funOver function to stop the game
        funOver();
      
    }
  else
  // slow down the time
  timer--;
  // call the following function will change the time to the new value
  Time.changeScore("" + theTime);
}
  
/**
 * randomGballs is a function to put the Gold balls on the world randomly
 * 
 */

public void randomGballs()
{
    // y takes any random positions
     int y=Greenfoot.getRandomNumber(500);
     
    // Gold balls comes from right to left
    // My world coordinations are 1000*600
    // now the Gold balls' X coordination should start from 1001, Y coordination takes numbers randomly
    addObject(new Gball(),1001, y);

}



/**
 * randomSballs is a function to put the silver balls on the world randomly
  */
public void randomSballs()
 {
     // y takes any random positions
    int y=Greenfoot.getRandomNumber(400)+1;
      // Silver balls comes from left to right
    // now the Gold balls' X coordination should start from 0, Y coordination takes numbers randomly
    addObject(new Sball(),0, y);
    }
    
/**
     * funOver is a function that pop up a megssage when the game is over
     */
    public void funOver()
    {
       // add the Msg object which displys the " Game Over" message and the score that the player got
       // The message takes X and Y coordinations which determined by getWidth()/2,getHeight()/2  [ the middle of the screen]
        addObject(new Msg(Player.getScore()),getWidth()/2,getHeight()/2);
        // After the message pop up the game stops
        Greenfoot.stop();
    }
    
    
    }    


